﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
Sub Class_Globals
	Private mDialogs As List
	Private xui As XUI
	Public Base As B4XView
	Private mBlurBackground As Boolean
	Private mParent As B4XView
	Public ShowAboveOtherDialogs As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As B4XView)
	mParent = Parent
	mDialogs.Initialize
End Sub

Public Sub GetBlurBackground() As Boolean
	Return mBlurBackground
End Sub

Public Sub SetBlurBackground(BlurBackground As Boolean)
	mBlurBackground = BlurBackground
	For Each dlg As B4XDialog2 In mDialogs
		If dlg.IsInitialized Then dlg.BlurBackground = mBlurBackground
	Next
End Sub

Public Sub Size () As Int
	Return mDialogs.Size
End Sub

Public Sub CreateDialog() As B4XDialog2
	Dim dlg As B4XDialog2
	dlg.Initialize(mParent)
	CleanClosedDialogs
	mDialogs.Add(dlg)
	Return dlg
End Sub

Public Sub GetTopMostDialog() As B4XDialog2
	For i = mDialogs.Size - 1 To 0 Step -1
		Dim dlg As B4XDialog2 = mDialogs.Get(i)
		If dlg.IsInitialized And dlg.Visible Then 
			Return dlg
		End If
	Next
	Dim dummy As B4XDialog2
	Return  dummy
End Sub

Public Sub CloseTopMostDialog(Result As Int) As Boolean
	Dim dlg As B4XDialog2
	dlg = GetTopMostDialog
	If dlg.IsInitialized Then 
		dlg.Visible = False
		Return dlg.Close(xui.DialogResponse_Cancel)
	End If
	Return False
End Sub

Public Sub CleanClosedDialogs()
	For i = mDialogs.Size - 1 To 0 Step -1
		Dim dlg As B4XDialog2 = mDialogs.Get(i)
		If dlg.IsInitialized And dlg.Visible=False Then mDialogs.RemoveAt(i)
	Next
End Sub